/*  Copyright (C) 1999  Peter Hellman UMPLUG

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author contact: peter@umplug.org
*/

/*  defines */
#define VERSION "fiprad version 0.6C Copyright (C) 1999 Peter Hellman UMPLUG \nGPL software, see Gnu Public License\n"
#define SQLSERVER "localhost"
#define SQLUSER "fipra"
#define SQLPASSWD "umplug"
#define SQLDATABASE "fipra"
#define SQLSOCK "/tmp/mysql.sock"
#define SQLCONNECT 1
#define SQLDISCONNECT 2
#define SQLCBNAME "ipblock"
#define SQLACCTABLE "fipra_account"
#define SQLCBRABLE "fipra_blocks"
#define EXIT_ERROR 1
#define EXIT_NORMAL 0
#define CHARBUF 126
#define DEFAULT_TIME 120
/* includes */
#include<stdio.h>
#include<stdlib.h>
#include<signal.h>
#include<mysql/mysql.h>
#include<string.h>
#include<linux/fipra.h>
#include<syslog.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/ioctl.h>
#include<fcntl.h>
#include<error.h>
#include<errno.h>
#include<sys/utsname.h>
#include<time.h>
#include<dirent.h>
/* declares */
struct ops {
	char sqlfile[20];
	char sqlserver[40];
	char sqluser[40];
	char sqlpwd[40];
	char sqldb[40];
	short int asec;
	short  daemon;
	short int nosql;
	short int sqlfuckup;
	short int hasdump;
	short int lognull;
} *opcodes;
struct _iptext{
	char ip[16];
      
};
struct iparr {
	struct _iptext ip[256]; 
	fipra_ipentry ipdata[256];
} *sqltable;

/* global stuff */
MYSQL *sqlp;
fipra_rec *rec, *sqlrec, *mask;
fipra_table *ktable;
struct utsname *sysname;
int fd;
/* functions */
int main(int argc, char *argv[]);
void sighand(int); /* Signal handler, using POSIX signal interface */
void sqlhand(int); /* Connecting and disconnecting to SQL server */
char *stripnl(char *); /* Removes ending newline character from string */
unsigned long int strtoint(char *); /* converts a ip number in ASCII to ul int */
void inttostr(unsigned long int, char *); /* converts a ip number in ul int to ASCII string */
void fiprad_init(char *); /* allocated memory, calls sqlinit etc. */
void fiprad_exit(int); /* Frees memory, closes files and so on */
void getsqlrec(void); /* Fills fipra_rec with c-blocks from SQL server */
void start_cycle(void); /* staring working cycle, called at start and from SIGALRM */
void writesqltable(void); /* writes table to SQL */
void getktable(int recno); /* reads data from kernel space */
void getsqltable(int recno); /* reads logged blocks from SQL */
void getkrec(void); /* reads logged blocks from kernel */
void sleep_infinite(void); /* take a guess */
void writefile(void); /* The non SQL record saving routine thingie. Also used at SQL conn loss */
void spool(void); /* spool file dumped data to SQL */ 
/* void addkrec(void); */
void cmprecs(void); /* checks wether kernel log rec. and the SQL counterpart matches, fixes differance */
void getsmask(int); /* This one claculates subnet walues, shall be re written to be in the getsqlrec */






